"""
Django settings for ucl_test_engine project.

Generated by 'django-admin startproject' using Django 4.0.6.

For more information on this file, see
https://docs.djangoproject.com/en/4.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.0/ref/settings/
"""

import asyncio
import logging
import os
from pathlib import Path

import environ

logger = logging.getLogger(__name__)

env = environ.FileAwareEnv(
    # set casting, default value
    DEBUG=(bool, False)
)

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent

# Take environment variables from .env file
environ.Env.read_env(os.path.join(BASE_DIR, ".env"))

DISABLE_AUTHENTICATION: bool = env.bool("DISABLE_AUTHENTICATION", default=False)
if DISABLE_AUTHENTICATION is True:
    logger.warning("!!! Authentication is disabled !!!")


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = env.str("DJANGO_SECRET_KEY")

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG: bool = env.bool("DJANGO_DEBUG", default=False)

ENABLE_API_DOCU: bool = env.bool("ENABLE_API_DOCU", default=False)
if DEBUG is False:
    # set to false because static files are not served when debug is false
    ENABLE_API_DOCU = False
ENABLE_DJANGO_AUTH: bool = env.bool("ENABLE_DJANGO_AUTH", default=False)
ENABLE_ADMIN_SITE: bool = env.bool("ENABLE_ADMIN_SITE", default=False)

ALLOWED_HOSTS: list[str] = env.list("ALLOWED_HOSTS")
CORS_ALLOWED_ORIGINS: list[str] = env.list("CORS_ALLOWED_ORIGINS")

CORS_ORIGIN_ALLOW_ALL: bool = env.bool("CORS_ORIGIN_ALLOW_ALL", default=False)

# added because of invalid urls due to forwarding.
USE_X_FORWARDED_HOST = True

CORS_ALLOW_HEADERS = [
    "authorization",
    "content-type",
]

SECURE_SSL_REDIRECT: bool = env.bool("SECURE_SSL_REDIRECT", default=True)
SECURE_REDIRECT_EXEMPT: list[str] = env.list("SECURE_REDIRECT_EXEMPT", default=[])
SECURE_PROXY_SSL_HEADER: tuple[str, str] | None = env.tuple("SECURE_PROXY_SSL_HEADER", default=None)
SESSION_COOKIE_SECURE: bool = env.bool("SESSION_COOKIE_SECURE", default=True)
CSFR_COOKIE_SECURE: bool = env.bool("CSFR_COOKIE_SECURE", default=True)
CSP_FRAME_ANCESTORS = "'none'"

SECURE_HSTS_SECONDS: int = env.int("SECURE_HSTS_SECONDS", default=31536000)
SECURE_HSTS_INCLUDE_SUBDOMAINS: bool = env.bool("SECURE_HSTS_INCLUDE_SUBDOMAINS", default=True)

CSP_SCRIPT_SRC = ["'self'", "'unsafe-inline'"]
CSP_STYLE_SRC = ["'self'", "'unsafe-inline'"]
CSP_IMG_SRC = ["'self'", "data:", "https://www.w3.org/2000/svg"]
CSP_WORKER_SRC = ["'self'", "blob:"]

# Application definition
CORE_APPS = [
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
]

THIRD_LEVEL_APPS = [
    "rest_framework",
    "corsheaders",
    "drf_spectacular",
    "drf_spectacular_sidecar",
    "django_q",
]

OWN_APPS = ["ucl_test_engine", "keycloak"]
if DISABLE_AUTHENTICATION is True:
    OWN_APPS.remove("keycloak")

INSTALLED_APPS = CORE_APPS + THIRD_LEVEL_APPS + OWN_APPS

MIDDLEWARE = [
    "ucl_test_engine.middleware.health_check.HealthCheckMiddleware",
    "keycloak.middleware.UclTestEngineHeaderMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "corsheaders.middleware.CorsMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "csp.middleware.CSPMiddleware",
    "djangorestframework_camel_case.middleware.CamelCaseMiddleWare",
]
if DISABLE_AUTHENTICATION is True:
    MIDDLEWARE.remove("keycloak.middleware.UclTestEngineHeaderMiddleware")


# SILENCED_SYSTEM_CHECKS = ["fields.E300", "fields.E307"]

REST_FRAMEWORK = {
    # Use Django's standard `django.contrib.auth` permissions,
    # or allow read-only access for unauthenticated users.
    # For Development use basic auth
    "DEFAULT_AUTHENTICATION_CLASSES": [
        "keycloak.authentication.KeycloakAuthBackend",
    ],
    "DEFAULT_PERMISSION_CLASSES": ["rest_framework.permissions.IsAuthenticated"],
    "DEFAULT_THROTTLE_CLASSES": [
        "rest_framework.throttling.AnonRateThrottle",
        "rest_framework.throttling.UserRateThrottle",
    ],
    "DEFAULT_THROTTLE_RATES": {
        "anon": env.str("THROTTLE_RATE_ANON", default="0/day"),
        "user": env.str("THROTTLE_RATE_USER", default="1000/day"),
    },
    "DEFAULT_RENDERER_CLASSES": [
        # "rest_framework.renderers.JSONRenderer",
        # "rest_framework.renderers.BrowsableAPIRenderer",
        "ucl_test_engine.renderers.JSONResponseRenderer",
    ],
    "DEFAULT_PARSER_CLASSES": (
        "djangorestframework_camel_case.parser.CamelCaseFormParser",
        "djangorestframework_camel_case.parser.CamelCaseMultiPartParser",
        "djangorestframework_camel_case.parser.CamelCaseJSONParser",
    ),
    "DEFAULT_SCHEMA_CLASS": "drf_spectacular.openapi.AutoSchema",
    "EXCEPTION_HANDLER": "ucl_test_engine.services.error_handling.exception_handler",
}
if DISABLE_AUTHENTICATION is True:
    REST_FRAMEWORK["DEFAULT_AUTHENTICATION_CLASSES"].remove(
        "keycloak.authentication.KeycloakAuthBackend"
    )
    REST_FRAMEWORK["DEFAULT_AUTHENTICATION_CLASSES"].append(
        "ucl_test_engine.auth.basic_auth_auto_login_system_user.BasicAuthAutoLoginSystemUser"
    )

API_ROOT = "api/v1"

SPECTACULAR_SETTINGS = {
    "SWAGGER_UI_DIST": "SIDECAR",  # shorthand to use the sidecar instead
    "SWAGGER_UI_FAVICON_HREF": "SIDECAR",
    "REDOC_DIST": "SIDECAR",
    "VERSION": API_ROOT,
    "POSTPROCESSING_HOOKS": [
        "drf_spectacular.contrib.djangorestframework_camel_case.camelize_serializer_fields",
        "ucl_test_engine.services.error_handling.inject_errors_to_listing",
    ],
}

if ENABLE_DJANGO_AUTH:
    debug_authentication = [
        "rest_framework.authentication.BasicAuthentication",
        "rest_framework.authentication.SessionAuthentication",
    ]
    REST_FRAMEWORK["DEFAULT_AUTHENTICATION_CLASSES"] += debug_authentication

ROOT_URLCONF = "urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

WSGI_APPLICATION = "wsgi.application"


# Database
# https://docs.djangoproject.com/en/4.0/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql",
        "HOST": env.str("POSTGRES_HOST"),
        "NAME": env.str("POSTGRES_DB"),
        "PASSWORD": env.str("POSTGRES_PASSWORD"),
        "USER": env.str("POSTGRES_USER"),
        "PORT": env.str("POSTGRES_PORT", default="5432"),
    }
}


# Password validation
# https://docs.djangoproject.com/en/4.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.0/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "UTC"

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.0/howto/static-files/

STATIC_URL = "static/"

# Default primary key field type
# https://docs.djangoproject.com/en/4.0/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

KEYCLOAK_CONFIG = {
    # check default setting in keycloak.settings
    "CLIENT_ID": env.str("KEYCLOAK_CLIENT_ID"),
    "CLIENT_SECRET": env.str("KEYCLOAK_CLIENT_SECRET"),
    "SERVER_URL": env.str("KEYCLOAK_SERVER_URL"),
    "REALM": env.str("KEYCLOAK_REALM"),
    "AUDIENCE": env.str("KEYCLOAK_AUDIENCE", default=None),
    "ISSUER": env.str("KEYCLOAK_ISSUER", default=None),
    "VALIDATE_ISSUER": env.bool("KEYCLOAK_VALIDATE_ISSUER", default=True),
    "CLIENT_ID_FOR_AUTHZ_ROLES": env.str("KEYCLOAK_CLIENT_ID_FOR_AUTHZ_ROLES"),
    "VERIFY_CERTIFICATE": env.bool("KEYCLOAK_VERIFY_CERTIFICATE", default=True),
}
# remove key if value is None otherwise default value from keycloak config won't be used.
if KEYCLOAK_CONFIG["ISSUER"] is None:
    del KEYCLOAK_CONFIG["ISSUER"]

if DISABLE_AUTHENTICATION is True:
    KEYCLOAK_CONFIG = {}

# django-q settings
Q_CLUSTER = {
    "name": env.str("Q_CLUSTER_NAME", "UclCluster"),
    "workers": env.int("Q_CLUSTER_WORKERS", default=4),
    "timeout": env.int("Q_CLUSTER_TIMEOUT", default=90),
    "retry": env.int("Q_CLUSTER_RETRY", default=120),
    "queue_limit": env.int("Q_CLUSTER_QUEUE_LIMIT", default=50),
    "orm": "default",
    "sync": env.bool("Q_CLUSTER_SYNC", default=False),
    "catch_up": env.bool("Q_CLUSTER_CATCH_UP", default=False),
    "max_attempts": env.int("Q_CLUSTER_MAX_ATTEMPTS", default=1),
}


SIEM_BASE_URL: str = env.str("SIEM_BASE_URL", default="http://localhost:8002")
SIEM_VERIFY_SSL_CERTIFICATE: bool = env.bool("SIEM_VERIFY_SSL_CERTIFICATE", default=False)
OPENSEARCH_BASE_URL: str = env.str("OPENSEARCH_BASE_URL", default="http://localhost:9200")
OPENSEARCH_USER_NAME: str = env.str("OPENSEARCH_USER_NAME", default="admin")
OPENSEARCH_USER_PASSWORD: str = env.str("OPENSEARCH_USER_PASSWORD", default="admin")
OPENSEARCH_VERIFY_SSL_CERTIFICATE: bool = env.bool(
    "OPENSEARCH_VERIFY_SSL_CERTIFICATE", default=False
)
OPENSEARCH_PAGINATION_LIMIT: int = env.int("OPENSEARCH_PAGINATION_LIMIT", default=10000)
MAX_WAITING_TIME_TO_ABORT_EXECUTION_IN_SEC: float = env.float(
    "MAX_WAITING_TIME_TO_ABORT_EXECUTION_IN_SEC", default=86400
)

USE_WINDOWS_SELECTOR_EVENT_LOOP_POLICY: bool = env.bool(
    "USE_WINDOWS_SELECTOR_EVENT_LOOP_POLICY", default=False
)
if USE_WINDOWS_SELECTOR_EVENT_LOOP_POLICY is True:
    asyncio.set_event_loop_policy(asyncio.WindowsSelectorEventLoopPolicy())
